var gsti;
var currentStories = new Array();
var playing = true;

//getElementById
function $ei(id, parentNode) {
	parentNode = parentNode || document;
	return parentNode.getElementById(id);
}

function fetchData(url, handler) {
	//alert("inside fetchData");
        $ei('diggIndicator').style.display = '';
        $ei("diggIndicator").setAttribute('mode', 'undetermined');
	var request = Components.
              classes["@mozilla.org/xmlextras/xmlhttprequest;1"].
              createInstance();

	// QI the object to nsIDOMEventTarget to set event handlers on it:

	request.QueryInterface(Components.interfaces.nsIDOMEventTarget);
	request.addEventListener("load", handler, false);
        request.addEventListener("error", handleError, false);

	// QI it to nsIXMLHttpRequest to open and send the request:

	request.QueryInterface(Components.interfaces.nsIXMLHttpRequest);
	request.open("GET", url, true);
	request.send(null);
        //$ei('diggIndicator').style.display = '';

}

function handleError(e) {
        $ei('storyList').appendItem("!! Error accessing Digg !!");
        //$ei('diggIndicator').style.display = 'none';
}

function populateMenu(e) {
    XHR = e.target;
	data = decodeJson(XHR.responseText);
    topics = data.topics;
    containers = new Array();

    while ($ei('topicPopup').firstChild) {
            $ei('topicPopup').removeChild($ei('topicPopup').firstChild);
    }

    topics.forEach(function (topic) {
        menu = document.createElement('menu');
        menu.setAttribute('id', topic.short_name + 'Menu');
        menu.setAttribute('label', topic.name);
        menu.setAttribute('accesskey', topic.name.charAt(0));

        menupopup = document.createElement('menupopup');
        menupopup.setAttribute('id', topic.short_name + 'Popup');

        ['All', 'Popular', 'Upcoming', 'Hot', 'Top'].forEach(
            function (label) {
                menuitem = document.createElement('menuitem');
                menuitem.setAttribute('label', label);
                menuitem.setAttribute('value', '/topic/' + topic.short_name + '/' + label.toLowerCase());
                menuitem.setAttribute('accesskey', label.charAt(0));
                menuitem.setAttribute('oncommand', "setEndPoint(this.value)");
                menupopup.appendChild(menuitem);
            }
        );
        menu.appendChild(menupopup);
        $ei('topicPopup').appendChild(menu);

        containers.push(topic.container);
    });

    while ($ei('containerPopup').firstChild) {
            $ei('containerPopup').removeChild($ei('containerPopup').firstChild);
    }

    filteredContainers = {name: [], short_name: []};
    containers.forEach(function (container) {
        name = container.name;
        short_name = container.short_name;
        if (filteredContainers.name.indexOf(name) == -1) {
            filteredContainers.name.push(name);
            filteredContainers.short_name.push(short_name);
        }
    });

    for (i=0; i<filteredContainers.name.length; i++) {
        menu = document.createElement('menu');
        menu.setAttribute('id', filteredContainers.short_name[i] + 'Menu');
        menu.setAttribute('label', filteredContainers.name[i]);
        menu.setAttribute('accesskey', filteredContainers.name[i].charAt(0));

        menupopup = document.createElement('menupopup');
        menupopup.setAttribute('id', filteredContainers.short_name[i] + 'Popup');

        ['All', 'Popular', 'Upcoming', 'Hot', 'Top'].forEach(
            function (label) {
                menuitem = document.createElement('menuitem');
                menuitem.setAttribute('label', label);
                menuitem.setAttribute('value', '/container/' +
                    filteredContainers.short_name[i] + '/' + label.toLowerCase());
                menuitem.setAttribute('accesskey', label.charAt(0));
                menuitem.setAttribute('oncommand', "setEndPoint(this.value)");
                menupopup.appendChild(menuitem);
            }
        );

        menu.appendChild(menupopup);
        $ei('containerPopup').appendChild(menu);
    }
    $ei('diggIndicator').style.display = 'none';
}

function populateStoryList(e) {
	XHR = e.target;
	//Application.console.log(XHR.responseText);
	data = decodeJson(XHR.responseText);
	stories = data.stories;

    while ($ei('storyList').firstChild) {
        $ei('storyList').removeChild($ei('storyList').firstChild);
    }

    var newStories = new Array();
    //Application.console.log(stories.length);

	stories.forEach(function (story) {
        newStories.push(story.id);
		//Application.console.log(i + " " + story.title + " " + story.id);

        listitem = $ei('storyList').appendChild(document.createElement('richlistitem'));
        listitem.id = "story_" + story.id;
        listitem.setAttribute('title', story.title);

        if (currentStories.indexOf(story.id) != -1) listitem.new = false;
    });
    currentStories = newStories;

    //Adaptive update interval code START
    sum = 0;
    weights = [4, 3, 2, 1]
    date = (stories[0].promote_date != null) ? 'promote_date' : 'submit_date';
    stories.sort(function (a, b) {
        if (a[date] > b[date]) return -1;
        else if (a[date] < b[date]) return 1;
        return 0;
    });
    for (i=0; i<Math.min(4, stories.length-1); i++) {
        diff = stories[i][date] - stories[i+1][date];
        sum += weights[i]*diff;
    }
    updateInterval = Math.round(
        sum*1000/weights
        .splice(0,Math.min(4, stories.length-1))
        .reduce(function(a, b){return a + b;})
    );
    //Application.console.log(updateInterval);

    var prefs = Application.extensions.get("diggsidebar@abhinavsarkar.net").prefs;

    if (updateInterval > 0) {
        previousUpdateInterval = prefs.get("updateinterval").value;
        prefs.get("updateinterval").value = updateInterval;

        updateIntervalDecay = prefs.get("updateintervaldecay").value;

        if (previousUpdateInterval == updateInterval)
            prefs.get("updateintervaldecay").value = updateIntervalDecay + 1;
        else
            prefs.get("updateintervaldecay").value = 0;
    }
    window.clearTimeout(gsti);

    updateInterval = prefs.get("updateinterval").value;
    updateIntervalDecay = prefs.get("updateintervaldecay").value;

    timeout = Math.round(updateInterval*(Math.pow(1.5, updateIntervalDecay)));
    gsti = window.setTimeout(getStories, timeout);
    //Adaptive update interval code END

    $ei('diggIndicator').style.display = 'none';
}

function populateDescription(e) {
	XHR = e.target;
    //Application.console.log(XHR.responseText);
	data = decodeJson(XHR.responseText);
	story = data.stories[0];

    now = new Date();
    if (story.promote_date != null)
        then = new Date(story.promote_date*1000);
    else
        then = new Date(story.submit_date*1000);
    diff = Math.max(now - then, 0)

    hr = Math.floor(diff/(1000*3600));
    min = Math.floor(diff/(1000*60)) - 60*hr;

    listitems = document.getElementsByTagName('richlistitem');
    for (i=0; i<listitems.length; i++) {
            listitems[i].hideDesc();
    }

    li = $ei('story_'+ story.id)

	storyDate = ((hr > 0) && (min > 0)) ?
        (hr + " hr " + min + " mins ago") :
        ((hr == 0) && (min > 0)) ?
        (min + " mins ago") :
        ((hr == 0) && (min == 0)) ?
        "just now" : "";
    li.setAttribute('date', storyDate);
	li.setAttribute('status', story.status);
	li.setAttribute('container', story.container.name);
	li.setAttribute('topic', story.topic.name);
	li.setAttribute('username', story.user.name);
    li.setAttribute('userlink', "http://digg.com/users/" + story.user.name);
	li.setAttribute('diggs', story.diggs);
	li.setAttribute('comments', story.comments);
	li.setAttribute('desc', story.description);
	li.setAttribute('link', story.link);
	li.setAttribute('href',  story.href);

    li.read = true;
    li.new = false;
    li.showDesc()

    $ei('diggIndicator').style.display = 'none';
}

function getStories() {
    var prefs = Application.extensions.get("diggsidebar@abhinavsarkar.net").prefs;
    ep = prefs.get("endpoint").value || '';
    $ei('diggEndPoint').value = "digg" + ep;

    fetchData("http://services.digg.com/stories" + ep.replace(/\/all/g, '') +
        "?count=30" + "&type=json" +
		"&appkey=" + encodeURIComponent("http://diggsidebar.googlepages.com"),
		populateStoryList);
    //gsti = window.setTimeout(getStories,          prefs.getIntPref("extensions.diggsidebar.updateinterval"));
}

function getDescription(storyId) {
    if (storyId == null) return;
	fetchData("http://services.digg.com/story/" + storyId + "?type=json" +
		"&appkey=" + encodeURIComponent("http://diggsidebar.googlepages.com"),
		populateDescription);
}

function createMenu() {
        fetchData("http://services.digg.com/topics" + "?type=json" +
		"&appkey=" + encodeURIComponent("http://diggsidebar.googlepages.com"),
                populateMenu);
}

function openInTab(href) {
        var mainWindow = window.QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIWebNavigation)
                   .QueryInterface(Components.interfaces.nsIDocShellTreeItem)
                   .rootTreeItem
                   .QueryInterface(Components.interfaces.nsIInterfaceRequestor)
                   .getInterface(Components.interfaces.nsIDOMWindow);
        mainWindow.getBrowser().selectedTab = mainWindow.getBrowser().addTab(href);
}

function setEndPoint(ep) {
        var prefs = Application.extensions.get("diggsidebar@abhinavsarkar.net").prefs;
        prefs.get("endpoint").value = ep;
        window.clearTimeout(gsti);
        //window.clearInterval(psi);
        getStories();
}

function togglePlayPause() {
        if (playing) {
               window.clearTimeout(gsti);
               //window.clearInterval(psi);
               $ei('diggPlayPause').image = "chrome://diggsidebar/content/image/Play.png";
               $ei('diggPlayPause').setAttribute("tooltiptext", "Click to Start autoupdate");
               playing = false;
        } else {
                var prefs = Application.extensions.get("diggsidebar@abhinavsarkar.net").prefs;
                updateInterval = prefs.get("extensions.diggsidebar.updateinterval").value;
                updateIntervalDecay = prefs.get("extensions.diggsidebar.updateintervaldecay").value;

                timeout = Math.round(updateInterval*(Math.pow(1.5, updateIntervalDecay)));
                //newTimeout = Math.round(timeout*parseInt($ei("diggIndicator").getAttribute('value'))/100);
                gsti = window.setTimeout(getStories, timeout);
                //psi = window.setInterval(showProgress, Math.round(timeout/100));
                //window.setTimeout("window.clearInterval(psi)", newTimeout);
                $ei('diggPlayPause').image = "chrome://diggsidebar/content/image/Pause.png";
                $ei('diggPlayPause').setAttribute("tooltiptext", "Click to Pause autoupdate");
                playing = true;
        }
}

function decodeJson(string) {
  var json = Components.classes["@mozilla.org/dom/json;1"]
             .createInstance(Components.interfaces.nsIJSON);
  return json.decode(string);
};

/*TODO
 preferences
 toolbar button
 refresh button
 */
/*DONE
 v0.2
 added kdb navigation
 Added progressmeter
 added error notification
 added accesskeys
 added new story notification

 v0.2.1
 adaptive polling interval
 promote_date
 pause/play

 v0.5
 new ui
*/
